/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Button;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.api.Textbox;

import com.rjconsultores.ventaboletos.entidad.EsquemaAgrupacion;
import com.rjconsultores.ventaboletos.entidad.EsquemaAsiento;
import com.rjconsultores.ventaboletos.entidad.EsquemaCorrida;
import com.rjconsultores.ventaboletos.entidad.EsquemaTramo;
import com.rjconsultores.ventaboletos.service.EsquemaAgrupacionService;
import com.rjconsultores.ventaboletos.service.EsquemaCorridaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderEsquemaAgrupacion;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaEsquemaAgrupacionController")
@Scope("prototype")
public class BusquedaEsquemaAgrupacionController extends MyGenericForwardComposer {

	private static Logger log = Logger.getLogger(BusquedaEsquemaAgrupacionController.class);

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<EsquemaAgrupacion> plwEsquemaAgrupacion;

	@Autowired
	private EsquemaAgrupacionService esquemaAgrupacionService;

	@Autowired
	private EsquemaCorridaService esquemaCorridaService;

	private MyListbox esquemaAgrupacionList;
	private Paging pagingEsquemaAgrupacion;

	private Button btnPesquisa;
	private Intbox intNumero;
	private Textbox txtDesc;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		esquemaAgrupacionList.setItemRenderer(new RenderEsquemaAgrupacion());
		esquemaAgrupacionList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				EsquemaAgrupacion ea = (EsquemaAgrupacion) esquemaAgrupacionList.getSelected();
				verPeriodo(ea);
			}
		});

		btnPesquisa.focus();
		refreshLista();
	}

	private void verPeriodo(EsquemaAgrupacion ea) {
		if (ea == null) {
			return;
		}

		Map args = new HashMap();
		args.put("esquemaAgrupacion", ea);
		args.put("busquedaEsquemaAgrupacionController", this);
		args.put("esquemaAgrupacionList", esquemaAgrupacionList);

		openWindow("/gui/esquema_operacional/editarEsquemaAgrupacion.zul",
				Labels.getLabel("busquedaConfiguracionEsquemaAgrupacion.window.title"), args, MODAL);
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPeriodo(new EsquemaAgrupacion());
	}

	public void refreshLista() {
		HibernateSearchObject<EsquemaAgrupacion> busquedaCorrita =
				new HibernateSearchObject<EsquemaAgrupacion>(EsquemaAgrupacion.class,
						pagingEsquemaAgrupacion.getPageSize());

		busquedaCorrita.addFilterEqual("activo", Boolean.TRUE);

		Integer id = intNumero.getValue();

		if (id != null) {
			busquedaCorrita.addFilterEqual("numagrupacion", id);
		}

		String desc = txtDesc.getValue().equals("") ? "%%" : "%".concat(txtDesc.getValue()).concat("%");
		busquedaCorrita.addFilterLike("descagrupacion", desc);

		busquedaCorrita.addSortDesc("esquemaagrupacionId");

		plwEsquemaAgrupacion.init(busquedaCorrita, esquemaAgrupacionList, pagingEsquemaAgrupacion);

		if (esquemaAgrupacionList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaConfiguracionCorridaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public PagedListWrapper<EsquemaAgrupacion> getPlwEsquemaCorrida() {
		return plwEsquemaAgrupacion;
	}

	public void setPlwEsquemaCorrida(PagedListWrapper<EsquemaAgrupacion> plwEsquemaCorrida) {
		this.plwEsquemaAgrupacion = plwEsquemaCorrida;
	}

	public MyListbox getEsquemaCorridaList() {
		return esquemaAgrupacionList;
	}

	public void setEsquemaCorridaList(MyListbox esquemaCorridaList) {
		this.esquemaAgrupacionList = esquemaCorridaList;
	}

	public Paging getPagingEsquemaCorrida() {
		return pagingEsquemaAgrupacion;
	}

	public void setPagingEsquemaCorrida(Paging pagingEsquemaCorrida) {
		this.pagingEsquemaAgrupacion = pagingEsquemaCorrida;
	}

	public Button getBtnPesquisa() {
		return btnPesquisa;
	}

	public void setBtnPesquisa(Button btnPesquisa) {
		this.btnPesquisa = btnPesquisa;
	}

	public Intbox getIntNumero() {
		return intNumero;
	}

	public void setIntNumero(Intbox intNumero) {
		this.intNumero = intNumero;
	}

	public PagedListWrapper<EsquemaAgrupacion> getPlwEsquemaAgrupacion() {
		return plwEsquemaAgrupacion;
	}

	public void setPlwEsquemaAgrupacion(PagedListWrapper<EsquemaAgrupacion> plwEsquemaAgrupacion) {
		this.plwEsquemaAgrupacion = plwEsquemaAgrupacion;
	}

	public MyListbox getEsquemaAgrupacionList() {
		return esquemaAgrupacionList;
	}

	public void setEsquemaAgrupacionList(MyListbox esquemaAgrupacionList) {
		this.esquemaAgrupacionList = esquemaAgrupacionList;
	}

	public Paging getPagingEsquemaAgrupacion() {
		return pagingEsquemaAgrupacion;
	}

	public void setPagingEsquemaAgrupacion(Paging pagingEsquemaAgrupacion) {
		this.pagingEsquemaAgrupacion = pagingEsquemaAgrupacion;
	}

	public Textbox getTxtDesc() {
		return txtDesc;
	}

	public void setTxtDesc(Textbox txtDesc) {
		this.txtDesc = txtDesc;
	}

}
